using GarmentFactoryContracts.BusinessLogicsContracts;
using GarmentFactoryDataModels.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using GarmentFactoryContracts.BindingModels;
using GarmentFactoryContracts.SearchModels;
using Microsoft.Extensions.Logging;
using GarmentFactoryContracts.DI;

namespace GarmentFactoryView
{
    public partial class FormTextile : Form
    {
        private readonly ILogger _logger;
        private readonly ITextileLogic _logic;
        private int? _id;
        private Dictionary<int, (IComponentModel, int)> _textileComponents;
        public int Id { set { _id = value; } }
        public FormTextile(ILogger<FormTextile> logger, ITextileLogic logic)
        {
            InitializeComponent();
            _logger = logger;
            _logic = logic;
            _textileComponents = new Dictionary<int, (IComponentModel, int)>();
        }
        private void LoadData()
        {
            _logger.LogInformation("Загрузка компонент изделия");
            try
            {
                if (_textileComponents != null)
                {
                    dataGridView.Rows.Clear();
                    foreach (var pc in _textileComponents)
                    {
                        dataGridView.Rows.Add(new object[] { pc.Key, pc.Value.Item1.ComponentName, pc.Value.Item2 });
                    }
                    textBoxPrice.Text = CalcPrice().ToString();
                }
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, "Ошибка загрузки компонент изделия");
                MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK,
               MessageBoxIcon.Error);
            }
        }
        private void ButtonSave_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(textBoxName.Text))
            {
                MessageBox.Show("Заполните название", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (string.IsNullOrEmpty(textBoxPrice.Text))
            {
                MessageBox.Show("Заполните цену", "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            if (_textileComponents == null || _textileComponents.Count == 0)
            {
                MessageBox.Show("Заполните компоненты", "Ошибка",
                MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
            _logger.LogInformation("Сохранение изделия");
            try
            {
                var model = new TextileBindingModel
                {
                    Id = _id ?? 0,
                    TextileName = textBoxName.Text,
                    Price = Convert.ToDouble(textBoxPrice.Text),
                    TextileComponents = _textileComponents
                };
                var operationResult = _id.HasValue ? _logic.Update(model) :
               _logic.Create(model);
                if (!operationResult)
                {
                    throw new Exception("Ошибка при сохранении. Дополнительная информация в логах.");
                }
                MessageBox.Show("Сохранение прошло успешно", "Сообщение",
               MessageBoxButtons.OK, MessageBoxIcon.Information);
                DialogResult = DialogResult.OK;
                Close();
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, "Ошибка сохранения изделия");
                MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }

        private void ButtonCancel_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
            Close();
        }

        private void ButtonAdd_Click(object sender, EventArgs e)
        {
			var form = DependencyManager.Instance.Resolve<FormTextileComponent>();
			if (form.ShowDialog() == DialogResult.OK)
            {
				if (form.ComponentModel == null)
                {
					return;
				}
				_logger.LogInformation("Добавление нового компонента: {ComponentName} - {Count}",
				   form.ComponentModel.ComponentName, form.Count);
				if (_textileComponents.ContainsKey(form.Id))
				{
					_textileComponents[form.Id] = (form.ComponentModel, form.Count);
				}
				else
				{
					_textileComponents.Add(form.Id, (form.ComponentModel, form.Count));
				}
				LoadData();
			}
		}

        private void ButtonEdit_Click(object sender, EventArgs e)
        {
            if (dataGridView.SelectedRows.Count == 1)
            {
				var form = DependencyManager.Instance.Resolve<FormTextileComponent>();
				int id = Convert.ToInt32(dataGridView.SelectedRows[0].Cells[0].Value);
				form.Id = id;
				form.Count = _textileComponents[id].Item2;
				if (form.ShowDialog() == DialogResult.OK)
				{
                    if (form.ComponentModel == null)
                    {
						return;
					}
					_logger.LogInformation("Изменение компонента: {ComponentName} - {Count}",
						form.ComponentModel.ComponentName, form.Count);
					_textileComponents[form.Id] = (form.ComponentModel, form.Count);
					LoadData();
				}
            }
        }

        private void ButtonDel_Click(object sender, EventArgs e)
        {
            if (dataGridView.SelectedRows.Count == 1)
            {
                if (MessageBox.Show("Удалить запись?", "Вопрос",
               MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                {
                    try
                    {
                        _logger.LogInformation("Удаление компонента:{ ComponentName} - { Count}", dataGridView.SelectedRows[0].Cells[1].Value);
                        _textileComponents?.Remove(Convert.ToInt32(dataGridView.SelectedRows[0].Cells[0].Value));
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show(ex.Message, "Ошибка",
                       MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                    LoadData();
                }
            }
        }

        private void ButtonUpd_Click(object sender, EventArgs e)
        {
            LoadData();
        }

        private void FormTextile_Load(object sender, EventArgs e)
        {
            if (_id.HasValue)
            {
                _logger.LogInformation("Загрузка изделия");
                try
                {
                    var view = _logic.ReadElement(new TextileSearchModel
                    {
                        Id =
                   _id.Value
                    });
                    if (view != null)
                    {
                        textBoxName.Text = view.TextileName;
                        textBoxPrice.Text = view.Price.ToString();
                        _textileComponents = view.TextileComponents ?? new
                        Dictionary<int, (IComponentModel, int)>();
                        LoadData();
                    }
                }
                catch (Exception ex)
                {
                    _logger.LogError(ex, "Ошибка загрузки изделия");
                    MessageBox.Show(ex.Message, "Ошибка", MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                }
            }
        }
        private double CalcPrice()
        {
            double price = 0;
            foreach (var elem in _textileComponents)
            {
                price += ((elem.Value.Item1?.Cost ?? 0) * elem.Value.Item2);
            }
            return Math.Round(price * 1.1, 2);
        }
    }
}
